Program Neuronova_sit_backprop;

uses crt;

const prah = -1;
      n = 41;

var f, fs, fv, fp : Text;
    fd, fw : file of Real;
    klavesa : Char;
    c : Word; {astost vpisu performance}
    kroky : LongInt;
    vahy_hotovy : Boolean;
    i, j, k, vrstva1, vrstva2, vrstva3 : Integer;
    presnost, r, performance : Real;
    x : array [1..n] of Real; {[1..vrstva1 + 1]}
    suma1, vystup1, chyba1 : array [1..n] of Real; {[1..vrstva2 + 1]}
    suma2, vystup2, chyba2, spravny_vystup : array [1..n] of Real; {[1..vrstva3]}
    w1, dw1, dw1_suma : array [1..n, 1..n] of Real; {[1..vrstva1 + 1, 1..vrstva2]}
    w2, dw2, dw2_suma : array [1..n, 1..n] of Real; {[1..vrstva2 + 1, 1..vrstva3]}

procedure inicializace;
begin ClrScr;
      randomize;
      WriteLn ('Program "Neuronov s potan zptnou propagac"');
      WriteLn ('Nastaven mus bt v souboru "setup.txt".');
      WriteLn ('Data mus bt v souboru "data.txt".');
      assign (f, 'data.txt');
      assign (fd, 'data.dat');
      assign (fp, 'perform.txt');
      assign (fv, 'vysledek.txt');
      assign (fw, 'vahy.dat');
      assign (fs, 'setup.txt');
      reset (fs);
      ReadLn (fs, vrstva1);
      ReadLn (fs, vrstva2);
      ReadLn (fs, vrstva3);
      ReadLn (fs, presnost);
      ReadLn (fs, r);
      ReadLn (fs, c);
      close (fs);
      x [vrstva1 + 1] := prah;
      vystup1 [vrstva2 + 1] := prah;
      kroky := 0;
      reset (f); rewrite (fd);
      while SeekEOF (f) = false do
      begin for i := 1 to vrstva1 do begin read (f, x [i]); write (fd, x [i]) end;
            for k := 1 to vrstva3 do begin read (f, spravny_vystup [k]); write (fd, spravny_vystup [k]) end
      end;
      close (f); close (fd);
end;

procedure pracuj;
begin rewrite (fp);
      repeat kroky := kroky + 1;
             vahy_hotovy := true;
             for i := 1 to vrstva1 + 1 do for j := 1 to vrstva2 do dw1_suma [i,j] := 0;
             for j := 1 to vrstva2 + 1 do for k := 1 to vrstva3 do dw2_suma [j,k] := 0;
             performance := 0;
             reset (fd);
             while not EOF (fd) do
             begin for i := 1 to vrstva1 do read (fd, x [i]);
                   for k := 1 to vrstva3 do read (fd, spravny_vystup [k]);
                   for j := 1 to vrstva2 do
                   begin suma1 [j] := 0;
                         for i := 1 to vrstva1 + 1 do suma1 [j] := suma1 [j] + x [i] * w1 [i,j];
                         vystup1 [j] := 1 / (1 + exp (-suma1 [j]))
                   end;
                   for k := 1 to vrstva3 do
                   begin suma2 [k] := 0;
                         for j := 1 to vrstva2 + 1 do suma2 [k] := suma2 [k] + vystup1 [j] * w2 [j,k];
                         vystup2 [k] := 1 / (1 + exp (-suma2 [k]));
                         chyba2 [k] := spravny_vystup [k] - vystup2 [k];
                         if abs (chyba2 [k]) > presnost then vahy_hotovy := false;
                         if kroky mod c = 0 then
                         performance := performance + chyba2 [k] * chyba2 [k]
                   end;
                   for j := 1 to vrstva2 do
                   begin chyba1 [j] := 0;
                         for k := 1 to vrstva3 do
                         chyba1 [j] := chyba1 [j] + w2 [j,k] * vystup2 [k] * (1 - vystup2 [k]) * chyba2 [k]
                   end;
                   for i := 1 to vrstva1 + 1 do for j := 1 to vrstva2 do
                   begin dw1 [i,j] := x [i] * vystup1 [j] * (1 - vystup1 [j]) * chyba1 [j];
                         dw1_suma [i,j] := dw1_suma [i,j] + dw1 [i,j]
                   end;
                   for j := 1 to vrstva2 + 1 do for k := 1 to vrstva3 do
                   begin dw2 [j,k] := vystup1 [j] * vystup2 [k] * (1 - vystup2 [k]) * chyba2 [k];
                         dw2_suma [j,k] := dw2_suma [j,k] + dw2 [j,k]
                   end;
             end;
             if kroky mod c = 0 then WriteLn (fp, performance :0 :6, #9);
             for i := 1 to vrstva1 + 1 do for j := 1 to vrstva2 do
             w1 [i,j] := w1 [i,j] + r * dw1_suma [i,j];
             for j := 1 to vrstva2 + 1 do for k := 1 to vrstva3 do
             w2 [j,k] := w2 [j,k] + r * dw2_suma [j,k];
      until vahy_hotovy or KeyPressed and (kroky mod c = 0);
      close (fp)
end;

procedure vysledek;
begin reset (fd);
      rewrite (fv);
      WriteLn (fv, 'Vsledek uen neuronov st'); WriteLn (fv);
      for i := 1 to vrstva1 + 1 do for j := 1 to vrstva2 do
      WriteLn (fv, 'vha 1 ', i:3, j:3, #9, w1 [i,j] :7 :3);
      for j := 1 to vrstva2 + 1 do for k := 1 to vrstva3 do
      WriteLn (fv, 'vha 2 ', j:3, k:3, #9, w2 [j,k] :7 :3);
      WriteLn (fv);
      while not EOF (fd) do
      begin for i := 1 to vrstva1 do read (fd, x [i]);
            for k := 1 to vrstva3 do read (fd, spravny_vystup [k]);
            for j := 1 to vrstva2 do
            begin suma1[j] := 0;
                  for i := 1 to vrstva1 + 1 do suma1 [j] := suma1 [j] + x [i] * w1 [i,j];
                  vystup1 [j] := 1 / (1 + exp (-suma1 [j]))
            end;
            for k := 1 to vrstva3 do
            begin suma2 [k] := 0;
                  for j := 1 to vrstva2 + 1 do suma2 [k] := suma2 [k] + vystup1 [j] * w2 [j,k];
                  vystup2 [k] := 1 / (1 + exp (-suma2 [k]));
                  WriteLn (fv, spravny_vystup [k] :7 :3, #9, vystup2 [k] :7 :3, #9, spravny_vystup [k] - vystup2 [k] :7 :3)
            end;
      end;
      WriteLn (fv);
      WriteLn (fv, 'Vhy byly zmnny ', kroky, ' krt.');
      WriteLn ('Vsledek je v souboru "vysledek.txt".');
      rewrite (fw);
      for i := 1 to vrstva1 + 1 do for j := 1 to vrstva2 do write (fw, w1 [i,j]);
      for j := 1 to vrstva2 + 1 do for k := 1 to vrstva3 do write (fw, w2 [j,k]);
      close (fv); close (fd); close (fw)
end;

begin inicializace;
      WriteLn ('Zante-li uit, stisknte klvesu "N".');
      WriteLn ('Pokraujete-li v uen, stisknte klvesu "P".');
      WriteLn ('Zadte-li cokoli jinho, s zpracuje data bez uen.');
      klavesa := ReadKey; WriteLn (klavesa);
      case klavesa of
      'n', 'N' : begin for i := 1 to vrstva1 + 1 do for j := 1 to vrstva2 do w1 [i,j] := random (100) / 100 - 0.5;
                       for j := 1 to vrstva2 + 1 do for k := 1 to vrstva3 do w2 [j,k] := random (100) / 100 - 0.5;
                       pracuj; vysledek
                 end;
      'p', 'P' : begin reset (fw);
                       for i := 1 to vrstva1 + 1 do for j := 1 to vrstva2 do read (fw, w1 [i,j]);
                       for j := 1 to vrstva2 + 1 do for k := 1 to vrstva3 do read (fw, w2 [j,k]);
                       pracuj; vysledek
                 end;
      else       begin reset (fw);
                       for i := 1 to vrstva1 + 1 do for j := 1 to vrstva2 do read (fw, w1 [i,j]);
                       for j := 1 to vrstva2 + 1 do for k := 1 to vrstva3 do read (fw, w2 [j,k]);
                       vysledek
                 end;
      end;
end.